import { VNodeChildElement } from './renderer';
export declare type PlainObject = {
    [key: string]: any;
};
declare function defineMetadata(key: string, value: any, target: Object): void;
declare function getMetadata(key: string, target: Object): any;
export declare const Reflect: {
    defineMetadata: typeof defineMetadata;
    getMetadata: typeof getMetadata;
};
export declare function toHyphenCase(raw: string): string;
export declare function toCamelCase(raw: string): string;
export declare type CSSValue = string | number | CSSObject;
export interface CSSObject {
    [key: string]: CSSValue;
}
export declare function stringifyCSS(data: CSSObject, depth?: number): string;
export declare function templateOf(tagName: string): any;
export declare function elementTypeOf(tagName: string): "html" | "xml";
export declare type DelegateEventHandler = (event: Event, currentTarget: Element, detail: any) => any;
export declare function delegate(selector: string, handler: DelegateEventHandler): (this: Node, event: Event) => any;
export declare const documentReady: Promise<unknown>;
export declare function Fragment({ defaultSlot }: {
    defaultSlot?: VNodeChildElement[];
}): VNodeChildElement[];
declare type LanguageMap<T> = {
    [K in keyof T]: string;
};
interface I18nData<T> {
    [language: string]: () => Promise<LanguageMap<T>>;
}
export declare function createI18nScope<T = {}>(data: I18nData<T>, defaultLanguage: string): {
    loaded: Promise<void>;
    i18nTextOf: (key: keyof T) => LanguageMap<T>[keyof T];
};
export declare function promisify<T extends Event>(scope: string, element: Element): Promise<T>;
export declare function transitIn(element: HTMLElement, className: string, display?: string): Promise<TransitionEvent>;
export declare function animateIn(element: HTMLElement, className: string, display?: string): Promise<AnimationEvent>;
export declare function transitOut(element: HTMLElement, className: string): Promise<void>;
export declare function animateOut(element: HTMLElement, className: string): Promise<void>;
export {};
